#include "libvo2.h"

static int current_surface=0;
static vo2_surface_t surface[2];

// open hardware/lib, get capabilities
// this function will be called first, before any other control() or start() calls
// return:  1=success  0=failed
static int init(){

    return 1;
}

// control (get/set/query) device parameters
//  for example: query supported pixel formats, en/disable double buffering,
//  query hw/sw scaling capabilities, switch window/fullscreen,
//  get best matching resolution for a given image size etc...
static int control(int cmd, void* param){
    
    return -1;
}

// start drawing (set video mode, allocate image buffers etc.)
// w,h: requested surface size (actual size may be larger!!!)
// format: IMGFMT_* requested surface pixel format
// buffering: 0 - single temporary frame buffer (for draw_* stuff)
//            1 - single static buffer  (for win32 direct rendering)
//            2 - 2 static + 1 temp buffer (for mpeg direct rendering)
// flags: various things, like fullscreen, sw/hw zoom and vidmode change
// return: 1=success 0=fail (fail if pixel format or buffering not supported)
static int start(int w,int h,int format,int buffering,int flags){

    // open window / switch vidmode, set up surfaces etc...


    return 1;
}

static int stop(){
    // stop rendering, close device
    return 1;
}

// get destination surface (for direct rendering or generic draw_ functions)
// num: number of frame. 0 = temporary frame - can be dropped/modified
//                       1-2 = static frames - should not be modified
// Note:  mpeg will use 0,1,2 frames for B,Pf,Pb  (or fallback to 0-only)
//        win32 will use only 0
static vo2_surface_t* get_surface(int num){
    return &surface[current_surface];
}

static void flip_image(int num){
    // we can assume that num is valid (get_surface(num) will return non-NULL)
  
    // let's show surface[num]

    if(double_buffering) current_surface=current_surface^1; // swap buffers
}



